{***********************************************************
 Component: TMELabel ver.3.0

 Usefull when you want to change your TLabel font on MouseEnter event
 with only 1 added property: MEFont

 Author: Didier Cabal
         'Bellefont'
         31800 Saint-Gaudens, France
         tl: +33 (0)5 61 89 72 92
         e-mail: didier.cabale+delphi@gmail.com
         web-page: http://didier.cabale.free.fr

 history:
 version2.0 (02/02/2001):
       - MECursor property supressed, because Cursor property is sufficient

************************************************************}
unit MELabel;

interface

uses Windows, Classes, Messages, Controls, StdCtrls, graphics, Forms;

type
   TMELabel = class(TCustomLabel)
   private
     FMEFont: TFont;
     {FSFont is usefull for storing temporary the Font when MouseEnter}
     FSFont: TFont;
     FMouseInControl: boolean;
     procedure MESetFont(Value: TFont);
     procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
     procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
   protected
   published
     property Align;
     property Alignment;
     property Anchors;
     property AutoSize;
     property BiDiMode;
     property Caption;
     property Color;
     property Constraints;
     property DragCursor;
     property DragKind;
     property DragMode;
     property Enabled;
     property FocusControl;
     property Font;
     property ParentBiDiMode;
     property ParentColor;
     property ParentFont;
     property ParentShowHint;
     property PopupMenu;
     property ShowAccelChar;
     property ShowHint;
     property Transparent;
     property Layout;
     property Visible;
     property WordWrap;
     property OnClick;
     property OnContextPopup;
     property OnDblClick;
     property OnDragDrop;
     property OnDragOver;
     property OnEndDock;
     property OnEndDrag;
     property OnMouseDown;
     property OnMouseMove;
     property OnMouseUp;
     property OnStartDock;
     property OnStartDrag;
     property MEFont: TFont read FMEFont write MESetFont stored true;
{     property OnMouseEnter: TNotifyEvent read FOnMouseEnter write FOnMouseEnter;
     property OnMouseLeave: TNotifyEvent read FOnMouseLeave write FOnMouseLeave;}
   public
     constructor Create(AOwner: TComponent); override;
     destructor Destroy; override;
   end;

procedure Register;

implementation

{ TMELabel }

constructor TMELabel.Create(AOwner: TComponent);
begin
  inherited;
  FMEFont := TFont.Create;
//  Screen.Cursors[crHandCursor] := LoadCursor(HInstance, 'HAND');
//  Cursor := crHandCursor;
end;

procedure TMELabel.CMMouseEnter(var Message: TMessage);
begin
  inherited;
//  if not FMouseInControl {and Enabled }and IsForegroundTask then begin
  if not FMouseInControl {and Enabled }then begin
     FMouseInControl := True;
     FSFont := TFont.Create;
     FSFont.Assign(Font);
     Font.Assign(FMEFont);
  end;
end;

procedure TMELabel.CMMouseLeave(var Message: TMessage);
begin
  inherited;
  if FMouseInControl {and Enabled and not FDragging }then begin
     FMouseInControl := False;
     Font.Assign(FSFont);
     FSFont.Free;
  end;
end;

destructor TMELabel.Destroy;
begin
  FMEFont.Free;
  inherited;
end;

procedure TMELabel.MESetFont(Value: TFont);
begin
  FMEFont.Assign(Value);
end;

procedure Register;
begin
   RegisterComponents('DCComp', [TMELabel]);
end;

end.
